	
	//雑用関数
	
	function delpx( value ) {
		return Number( value.replace( /px/, "" ) );
	}

	function getSize( element, isBorder ) {
	/*	HTML要素のサイズを得る。
		isBorder	枠を含めたサイズにするかどうか。
	*/
		let w, h;
		let r = element.getBoundingClientRect();
		if( isBorder ) {
			w = r.width;
			h = r.height;
		} else {
			let s = getComputedStyle( element );
			let bl = delpx( s.borderLeftWidth );
			let bt = delpx( s.borderTopWidth );
			let br = delpx( s.borderRightWidth );
			let bb = delpx( s.borderBottomWidth );
			w = r.width - bl - br;
			h = r.height - bt - bb;
		}
		return { width : w, height : h };
	}


function AdditionalResize( element ) {
/*	クラス：　ある要素を親要素にフィットさせる
*/
	this.element = element;
	let s = getSize( this.element, true );
	this.initialWidth = s.width;
	this.initialHeight = s.height;
	this.element.style.transformOrigin = "0 0";
	
	this.onresizex = this.onresizex.bind( this );
	addEventListener( "resize", this.onresizex );
	this.onresizex();
}
AdditionalResize.prototype.setPosition = function( horizontal, vertical ) {
/*	親要素における位置を設定。
	horizontal	"l", "c", "r" のいずれか
	vertical	"t", "m", "b" のいずれか
*/
	this.verticalPosition = vertical ? vertical : "m";
	this.horizontalPosition = horizontal ? horizontal : "c";
	this.element.parentNode.style.position = "relative";
	this.element.style.position = "absolute";
	this.onresizex();
}
AdditionalResize.prototype.onresizex = function( e ) {
	let ps = getSize( this.element.parentNode, false );
	let horRate = ps.width / this.initialWidth;
	let verRate = ps.height / this.initialHeight;

	if( horRate < verRate ) {
		//横フィット
		this.element.style.transform = "scale(" + horRate + "," + horRate + ")";
		this.element.style.left = 0;
		let s = getSize( this.element, true );
		switch( this.verticalPosition ) {
			case "t": this.element.style.top = 0; break;
			case "b": this.element.style.top = ps.height - s.height + "px"; break;
			case "m": this.element.style.top = ( ps.height - s.height ) / 2 + "px"; break;
		}
	} else {
		//縦フィット
		this.element.style.transform = "scale(" + verRate + "," + verRate + ")";
		this.element.style.top = 0;
		let s = getSize( this.element, true );
		switch( this.horizontalPosition ) {
			case "l": this.element.style.left = 0; break;
			case "r": this.element.style.left = ps.width - s.width + "px"; break;
			case "c": this.element.style.left = ( ps.width - s.width ) / 2 + "px"; break;
		}
	}
}
